% SOLVER OPTIONS
TolFun_use  = 1E-8;                    % Set TolFun for minimizer
TolX_use    = 1E-5;                    % Set TolX for minimizer
MaxIter_use = 1000;                    % Set Maximum number of Iterations for solver


%--------------------------------------------------------------------------
% NUMERICAL SOLVER OPTIONS
%--------------------------------------------------------------------------

% Options to compute without analytical jacobian
opt.nojac = optimset('display','iter',...
    'MaxFunEvals',100000,...
    'MaxIter',MaxIter_use,...
    'TolFun',TolFun_use,...
    'TolX',TolX_use,...
    'FunValCheck','On');

% Options to compute with analytical jacobian
opt.jac = optimset('display','iter',...
    'MaxFunEvals',100000,...
    'MaxIter',MaxIter_use,...
    'TolFun',TolFun_use,...
    'TolX',TolX_use,...
    'FunValCheck','On',...
    'Jacobian','On',...
    'DerivativeCheck','Off');

% Options to test numerical jacobian
opt.test = optimset('display','iter',...
    'MaxFunEvals',100000,...
    'MaxIter',0,...
    'TolFun',TolFun_use,...
    'TolX',TolX_use,...
    'FunValCheck','On');

